leetcode-组合总和

 题目来自LeetCode,链接:combination-sum。具体描述为:给定一个无重复元素的数组 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的组合。candidates 中的数字可以无限制重复被选取。
说明:

  • 所有数字(包括 target)都是正整数。
  • 解集不能包含重复的组合。

 示例1:

输入: candidates = [2,3,6,7], target = 7,
所求解集为:
[
  [7],
  [2,2,3]
]

 示例2:

输入: candidates = [2,3,5], target = 8,
所求解集为:
[
  [2,2,2,2],
  [2,3,3],
  [3,5]
]

 整个的搜索过程可以看做生成一棵搜索树的过程,根节点为和为0,假设candidates有L个候选数,然后接下来会从根节点出发生成L个节点,各节点的和就是0+候选数,因为可以重复无限次,所以每次一个节点往下总是可以再生出L个节点来。同时考虑到候选数都是大于零的,所以当一个节点得到一个大于等于0的和之后,就可以停止了,等于0的话回溯到根节点就得到一个符合条件的组合。这就是回溯算法,也可以看做一种深度优先遍历。同时,可以先对candidates进行排序,以方便及时剪枝,也就是在对一个节点生成L个子节点的时候,发现到当前生成子节点为止的和已经大于等于0了,那么后面的子节点(和肯定大于0了)直接放弃即可。

 JAVA版代码如下:

class Solution {
    private void recursion(int[] candidates, int start, int target, List<Integer> oneSolution, List<List<Integer>> result) {
        for (int i = start; i < candidates.length; ++i) {
            if (candidates[i] == target) {
                List<Integer> temp = new LinkedList<>(oneSolution);
                temp.add(candidates[i]);
                result.add(temp);
            }
            else if (candidates[i] < target) {
                List<Integer> temp = new LinkedList<>(oneSolution);
                temp.add(candidates[i]);
                recursion(candidates, i, target - candidates[i], temp, result);
            }
            else {
                break;
            }
        }
    }

    public List<List<Integer>> combinationSum(int[] candidates, int target) {
        int L = candidates.length;
        List<List<Integer>> result = new LinkedList<>();    
        Arrays.sort(candidates);
        recursion(candidates, 0, target, new LinkedList<Integer>(), result);
        return result;
    }
}

 提交结果如下:

leetcode-组合总和

 Python版代码如下:

class Solution:
    def combinationSum(self, candidates: List[int], target: int) -> List[List[int]]:
        L = len(candidates)
        def recursion(candidates, start, target, oneSolution, result):
            for i in range(start, L):
                if candidates[i] == target:     #当前数等于target,找到一组符合的了
                    temp = oneSolution.copy()
                    temp.append(candidates[i])
                    result.append(temp)
                elif candidates[i] < target:    #当前数小于target,可以加入待选组合,看后面继续加入数是否可以符合条件
                    temp = oneSolution.copy()
                    temp.append(candidates[i])
                    recursion(candidates, i, target - candidates[i], temp, result)
                else:                           #当前数大于target,后面肯定没有符合条件的了,直接跳出
                    break

        candidates.sort()
        result = []
        recursion(candidates, 0, target, [], result)
        return result

 提交结果如下:

leetcode-组合总和
上一篇:Leetcode练习(Python):数组类:第39题:给定一个无重复元素的数组 candidates 和一个目标数 target ,找出 candidates 中所有可以使数字和为 target 的


下一篇:40-组合总和2